import java.io.*;
import java.util.*;
import java.util.regex.*;
import org.apache.tika.parser.pdf.*;
import org.apache.tika.sax.*;
import org.xml.sax.*;
import org.apache.tika.metadata.Metadata;  
import org.apache.tika.parser .*;
//import org.apache.tika.*;
//import org.apache.tika.exception.*;

public class Hw3 {
	//Creating a List of string where we will store keywords
	List<String> keywords;
	//Creating a PrintWrite object, to be used in writing in the file
	PrintWriter logfile;
	//Keywords to store number of files, keywords, number of files wth keywords
	int num_keywords, num_files, num_fileswithkeywords;
	//Hash map used to store count of keywrd viz a viz the name of keyword
	Map<String,Integer> keyword_counts;
	//Date object to store timestamp when the file is read
	Date timestamp;
	//private Object Boolean;

	/**
	 * constructor
	 * DO NOT MODIFY
	 */
	public Hw3() {
		//Initialization of Variables & other data structure
		keywords = new ArrayList<String>();
		num_keywords=0;
		num_files=0;
		num_fileswithkeywords=0;
		keyword_counts = new HashMap<String,Integer>();
		timestamp = new Date();
		try {
			logfile = new PrintWriter("log.txt");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	/**
	 * destructor
	 * DO NOT MODIFY
	 */
	protected void finalize() throws Throwable {
		try {
			logfile.close();
	    } finally {
	        super.finalize();
	    }
	}

	/**
	 * main() function
	 * instantiate class and execute
	 * DO NOT MODIFY
	 */
	public static void main(String[] args) {
		Hw3 instance = new Hw3();
		instance.run();
	}

	/**
	 * execute the program
	 * DO NOT MODIFY
	 */
	private void run() {

		// Open input file and read keywords
		try {
			BufferedReader keyword_reader = new BufferedReader(new FileReader("keywords.txt"));
			String str;
			while ((str = keyword_reader.readLine()) != null) {
				keywords.add(str);
				num_keywords++;
				keyword_counts.put(str, 0);
			}
			keyword_reader.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("Caught "+e);
		}

		// Open all pdf files, process each one
		File pdfdir = new File("./vault");
		File[] pdfs = pdfdir.listFiles(new PDFFilenameFilter());
		for (File pdf:pdfs) {
			num_files++;
			//For my testing i have created another PrintWriter file into my project diretcory
			/*PrintWriter fileSeq;
			try {
				fileSeq = new PrintWriter("fileSeq.txt");
				fileSeq.append("Filenumber :"+num_files+" Filename: "+pdf);
			} catch (FileNotFoundException e1) {
				e1.printStackTrace();
			}
			*/
			//Code for my testing ends here
			try 
			{
				//For every file in the pdfdir,process file function is called 
				//which reads file, extracts contents checks for keyword and update count 
				processfile(pdf);				
			}
			catch(Exception e)
			{
				System.out.println("Exception from run method Caught "+e);
			}			
		}
		
		//A test message to mark the completion of the program
		System.out.println("Mission Accomplished");
		
		// Print output file
		try {
			PrintWriter outfile = new PrintWriter("output.txt");
			outfile.print("Keyword(s) used: ");
			if (num_keywords>0) outfile.print(keywords.get(0));
			for (int i=1; i<num_keywords; i++) 
			outfile.print(", "+keywords.get(i));
			outfile.println();
			outfile.println("No of files processed: " + num_files);
			outfile.println("No of files containing keyword(s): " + num_fileswithkeywords);
			outfile.println();
			outfile.println("No of occurrences of each keyword:");
			outfile.println("----------------------------------");
			for (int i=0; i<num_keywords; i++) {
				String keyword = keywords.get(i);
				outfile.println("\t"+keyword+": "+keyword_counts.get(keyword));
				
			/* This code snippet prints in file if the number of files dealing with UFO are 9% of its vault corpus
			int threashold= (num_files *100)/9; 
			if(num_fileswithkeywords>threashold)
				outfile.println("FBIs search is not telling us the truth when it says only 9% of its vault corpus has to do with UFOs it seems something more is hiding in that rich treasure trove of information.");
			else
				outfile.println("FBIs search is telling us the truth when it says only 9% of its vault corpus has to do with UFOs. ");
			*/
			}
			outfile.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.out.println("Caught "+e);
		}
	}

	/**
	 * Process a single file
	 * 
	 * Here, you need to:
	 *  - use Tika to extract text contents from the file
	 *  - (optional) check OCR quality before proceeding
	 *  - search the extracted text for the given keywords
	 *  - update num_fileswithkeywords and keyword_counts as needed
	 *  - update log file as needed
	 * 
	 * @param f File to be processed
	 */
	private void processfile(File f) {

		/***** YOUR CODE GOES HERE *****/
		String handlerContent="";
		try {
			InputStream stream=new FileInputStream(f);//Input document
			//InputStream stream=new FileInputStream(".\\vault\\00000001 pages 1-249.pdf");
			ContentHandler handler= new BodyContentHandler(-1); //for extracted structured text
			Metadata metadata = new Metadata(); //document metadata for both input and output file
			PDFParser parser=new PDFParser(); //Parser parser=new AutoDetectParser() // For unknown MIME Types selects best parser
			ParseContext context =new ParseContext();
			parser.parse(stream,handler,metadata,context);   // parse the input stream			  
			handlerContent= handler.toString();			     // Store output handler text into a string
			//Uncomment this to see in SOP the current file being read
			System.out.println("Reading File "+num_files+" "+handlerContent.length());
			
		}
		catch (Exception ex)	
		{
			System.out.println("Caught "+ex);
			ex.printStackTrace();
		}
		catch(StackOverflowError t) {
            System.out.println("Caught "+t);
            t.printStackTrace();
		}
		
		boolean thisFileHasAKeyword=false; 
		for (int i=0; i<num_keywords; i++) {			
			String keyword = keywords.get(i);
			
				int keyLength=keyword.length();
				int keyThreshold=keyLength/3;			
				StreamTokenizer st = new StreamTokenizer(new StringReader(handlerContent));
				try {
					while (st.nextToken() != StreamTokenizer.TT_EOF) {
						
						System.out.println("st.sval "+st.toString());
					    if(st.ttype == StreamTokenizer.TT_WORD) 
					    	{
								int editDistance=getLevenshteinDistance(keyword,st.sval);
								//System.out.println("Found content: "+m.group());
								// to update the log file with a search hit
								if(editDistance<=keyThreshold)
					    			{
									keyword_counts.put(keyword, keyword_counts.get(keyword)+1);
									System.out.println("editDistance "+editDistance+"keyword,st.sval "+keyword+ " " +st.sval);
									updatelog(keyword,f.getName());
									thisFileHasAKeyword=true;
					    			}
					    	}
						}
					} catch (Exception e) {
					e.printStackTrace();
					System.out.println("editDistance exception is "+e);
					}

			}
			
		//Simply increments the number of files by 1 if file has any of the keywords from the list 
		if(thisFileHasAKeyword)
		{
			num_fileswithkeywords++;
		}
	}

	/**
	 * Update the log file with search hit
	 * Appends a log entry with the system timestamp, keyword found, and filename of PDF file containing the keyword
	 * DO NOT MODIFY
	 */
	private void updatelog(String keyword, String filename) {
		timestamp.setTime(System.currentTimeMillis());
		logfile.println(timestamp + " -- \"" + keyword + "\" found in file \"" + filename +"\"");
		logfile.flush();
	}

	/**
	 * Filename filter that accepts only *.pdf
	 * DO NOT MODIFY 
	 */
	static class PDFFilenameFilter implements FilenameFilter {
		private Pattern p = Pattern.compile(".*\\.pdf",Pattern.CASE_INSENSITIVE);
		public boolean accept(File dir, String name) {
			Matcher m = p.matcher(name);
			return m.matches();
		}
	}
	
	 /*
     * This class definition (or function) is downloaded from
     * the following location:
     *     [ http://www.java2s.com/Code/Java/Data-Type/FindtheLevenshteindistancebetweentwoStrings.htm ]
     * The source code has not been modified.
     * The file has the following copyright from the original author
     */
	  public static int getLevenshteinDistance(String s, String t) {
	 
	      if (s == null || t == null) {
	          throw new IllegalArgumentException("Strings must not be null");
	      	}
	      int n = s.length(); // length of s
	      int m = t.length(); // length of t

	      if (n == 0) {
	          return m;
	      } else if (m == 0) {
	          return n;
	      }

	      if (n > m) {
	          // swap the input strings to consume less memory
	          String tmp = s;
	          s = t;
	          t = tmp;
	          n = m;
	          m = t.length();
	      }

	      int p[] = new int[n+1]; //'previous' cost array, horizontally
	      int d[] = new int[n+1]; // cost array, horizontally
	      int _d[]; //placeholder to assist in swapping p and d

	      // indexes into strings s and t
	      int i; // iterates through s
	      int j; // iterates through t

	      char t_j; // jth character of t

	      int cost; // cost

	      for (i = 0; i<=n; i++) {
	          p[i] = i;
	      }

	      for (j = 1; j<=m; j++) {
	          t_j = t.charAt(j-1);
	          d[0] = j;

	          for (i=1; i<=n; i++) {
	              cost = s.charAt(i-1)==t_j ? 0 : 1;
	              // minimum of cell to the left+1, to the top+1, diagonally left and up +cost
	              d[i] = Math.min(Math.min(d[i-1]+1, p[i]+1),  p[i-1]+cost);
	          }

	          // copy current distance counts to 'previous row' distance counts
	          _d = p;
	          p = d;
	          d = _d;
	      }

	      // our last action in the above loop was to switch d and p, so p now 
	      // actually has the most recent cost counts
	      return p[n];
	  }

	
}

//Pattern p = Pattern.compile("\\b"+keyword+"s?\\b",Pattern.CASE_INSENSITIVE);
//Pattern p = Pattern.compile("\\b\\W"+keyword+"s?\\b",Pattern.CASE_INSENSITIVE);
//Pattern p = Pattern.compile("[0-9]{}//w[a-bA-B]+ or [0-9]{}//w["+keyword+"]++",Pattern.CASE_INSENSITIVE);
//Pattern p = Pattern.compile("[^a-z\\s]*"+keyword+"?[^\\s]*",Pattern.CASE_INSENSITIVE);
//Pattern p = Pattern.compile("[^\\s]*"+keyword+"?[^\\s]",Pattern.CASE_INSENSITIVE);
//Pattern p = Pattern.compile("[^\\s]*"+keyword+"s?\\b",Pattern.CASE_INSENSITIVE);
//Pattern p = Pattern.compile("[^\\s]*\\W*"+keyword+"s?\\b",Pattern.CASE_INSENSITIVE);
